function assertMiddleware(middleware) {
  var entryType = typeof middleware;

  if (entryType !== 'function') {
    throw new TypeError("A segment middleware must be a function, but a " + entryType + " is being passed");
  }
}

export var loadSegmentMiddlewares = function loadSegmentMiddlewares(_ref) {
  var optimizelyUserIdMiddleware = _ref.optimizelyUserIdMiddleware,
      optimizelySiteAttributeMiddleware = _ref.optimizelySiteAttributeMiddleware,
      customSourceMiddlewares = _ref.customSourceMiddlewares;
  window.analytics.ready(function () {
    customSourceMiddlewares.forEach(function (middleware) {
      assertMiddleware(middleware);
      window.analytics.addSourceMiddleware(middleware);
    });
    window.analytics.addDestinationMiddleware('Optimizely', [optimizelyUserIdMiddleware, optimizelySiteAttributeMiddleware]);
  });
};